; ******************************************************************************
; ****** Routinen fr die eingebauten AD-Wandler *******************************
; ****** enthlt die Messung des Helligkeitssenors 
; *****							ADC_CONV_C
; ******  UND
; ****** spter die Messung des freien AD-Ports



; ******************************************************************************
; ****** AD-Wandlung komplett IRQ-Routine **************************************
ADC_CONV_C:
	in	SAVE_STATUS_FLAG,STATUS_FLAG	; Rette StatusRegister da es verndert wird !!
	push	X_L
	push	X_H

	in	X_L, ADCL 		; immer zuerst CL ! auslesen - Messwert
	in 	X_H, ADCH		; dann CH sonst hngt AD-Wandler fest 
	; steuere die Beleuchtung anhand des Messwertes
	lsr	X_L			; oberen Wert in X_L packen
	sbrc	X_H, 0			; aus 10bit - 8bit machen
	ori	X_L, 128
	lsr	X_L
	sbrc	X_H, 1
	ori	X_L, 128		; fertige Messwert
	in	X_H, PORTC_D		; Art Hysterese
	sbrc	X_H, 1
	rjmp	Bel_Is_On
	;cpi	X_L, Hell_Schwelle_Min
	cp	X_L, REG_HELLIGK_SCHWELLE_MIN
	brlo	Bel_AN
	cbi	PORTC_D, 1
	rjmp	Bel_END
	Bel_Is_On:
	ldi	X_H, 10				; schwelle max errechnen (10 dazu sollte reichen)
	add	X_H, REG_HELLIGK_SCHWELLE_MIN	; berlauf in eingaberoutine abfragen (da max 240)
	;cpi	X_L, Hell_Schwelle_Max
	cp	X_L, X_H
	brlo	Bel_AN
	cbi	PORTC_D, 1
	rjmp	Bel_END
	Bel_AN:
	sbi	PORTC_D, 1
	Bel_END:
;	pop TEMP

	pop	X_H
	pop	X_L
	out	STATUS_FLAG,SAVE_STATUS_FLAG ; und Flags in orig. zustand
	reti	
; *** end AD-Wandlung komplett ***********************************************
