; ************************************************************************
; Zahlenwandlungen

; **** Hex zu Binr *********************************************
; **** wert in WORK2 wird an akt. position als binr ausgegeben *
; **** nach Subtraktionsverfahren :                             *
; **** wert minus 2hochx, neg ? dann 0 sonst 1..
; ****                        weiter mit 2hoch(x-1) bis null    *
; ***************************************************************
hex2bin_disp:
	push	DISPLAY_DAT		; zur Sicherheit vorerst
	push	TEMP			; zur Sicherheit
	ldi	TEMP, 128		; Startzhler 2hoch7
	hex_bin_start:
	sub	WORK2, TEMP		; Wert minux 2hochx
	brmi	hex_bin_neg		; negativ ?
	ldi	DISPLAY_DAT, '1'	;  nein dann 1
	rcall	Disp_Send_Data
	lsr	TEMP			; 2hoch(x-1)
	breq	hex_bin_end		; Null erreicht ?
	rjmp	hex_bin_start
	hex_bin_neg:
	ldi	DISPLAY_DAT, '0'	;  ja dann 0
	rcall	Disp_Send_Data
	add	WORK2, TEMP		; vorherg. Wert wiederherstellen
	lsr	TEMP			; 2hoch(x-1)
	breq	hex_bin_end		; Null erreicht ?
	rjmp	hex_bin_start		
	hex_bin_end:
	pop	TEMP
	pop	DISPLAY_DAT
	ret
; **** End Hex zu Binr ***************************************


; **** Hex zu Dezimal *******************************************
; **** wert in WORK2 wird an akt. position als binr ausgegeben *
; **** merhode wie oben mit RESTwertbildung                     *
; ***************************************************************
hex2dez_disp:			;WORK2 
	push	DISPLAY_DAT	; zeichen ausgeben und Zhler wieviel mal wert in 10hochX passt
	push	TEMP		; 10hochX
	push	WORK		; bentigt um asc() code dazu zu addieren, da addi fehlt
	ldi	TEMP, 100	; 10hoch2 
	hex_dec_new_start:
	clr 	DISPLAY_DAT	; wert frei machen
	hex_dez_start: 
	sub 	WORK2, TEMP	; wert - 10hochx
	brcs 	hex_dez_write	; berlauf ( ergebniss =  Wert Rest xx ) 
  	inc	DISPLAY_DAT	; und wert muss ermittelt werden
  	rjmp	hex_dez_start	
  	hex_dez_write:		 ; ermittelt dann ausgeben
  	ldi	WORK, 48	 ; asc() code 
	add 	DISPLAY_DAT, WORK ; und ausgeben
  	rcall 	Disp_Send_Data  
  	add	WORK2, TEMP	; vorhergehenden Wert wiederherstellen fr nchsten durchgang
	clr	WORK		; ** divison durch 10
	div_start: 
	subi 	TEMP, 10	; wert - 10hochx
	brcs 	div_erg		; berlauf ( ergebniss =  Wert Rest xx ) 
  	inc	WORK		; und wert muss ermittelt werden
  	rjmp	div_start	; **
  	div_erg:
  	mov	TEMP,WORK	; und ergebniss nach TEMP
	tst	TEMP		; ist komplett durchlaufen ?
	breq	hex_dec_end	
	rjmp	hex_dec_new_start	 	  	
  	hex_dec_end:  	
	pop	WORK
  	pop	TEMP
  	pop 	DISPLAY_DAT
	ret
; **** End Hex zu Dezimal ***************************************
